<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_graph_image_gradients.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>vx_tutorial_graph_image_gradients.c File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>Performs a Sobel filter followed by a magnitude node and phase node on the X and Y outputs of the Sobel filter.</p>
<p>In this tutorial we learn the below concepts,</p>
<ul>
<li>How to create OpenVX context, OpenVX image data object and OpenVX virtual image data object</li>
<li>How to read a BMP file and load the pixel values into the image data object</li>
<li>How to query the image data object for attributes like width, height</li>
<li>How to create OpenVX node and associate it with previously created graph</li>
<li>How to choose a CPU core for an OpenVX to execute on</li>
<li>How to schedule OpenVX graph for execution then execute the graph</li>
<li>How to query the node data object for attributes like width, height</li>
<li>How to query the graph data object for attributes like number of nodes and parameters</li>
<li>How to read pixel values from an image data object and save it as a BMP file</li>
<li>How to cleanup all created resources and exit the OpenVX application</li>
</ul>
<p>To include OpenVX interfaces include below file </p>
<div class="fragment"><pre class="fragment"><span class="preprocessor"> #include &lt;VX/vx.h&gt;</span>
</pre></div><p>Follow the comments in the function <a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a838f2ff5f2c2496ad0fee70c0c93f2b6" title="Tutorial Entry Point.">vx_tutorial_graph_image_gradients()</a> to understand this tutorial </p>

<p>Definition in file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

<p><a href="vx__tutorial__graph__image__gradients_8c_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a8118656bb5a60090a1dbffa402168438">IN_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Input file name.  <a href="#a8118656bb5a60090a1dbffa402168438"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#ac7b4da9c3d57efe0b9187f424dba9324">PHASE_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_phase_out.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Phase file name.  <a href="#ac7b4da9c3d57efe0b9187f424dba9324"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a477612b28de7f3778ec98290da147134">MAGNITUDE_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_magnitude_out.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Magnitude file name.  <a href="#a477612b28de7f3778ec98290da147134"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a27e19862e6e875abe96f110243d1b5aa">GRAD_X_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_grad_x_out.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gradient X file name.  <a href="#a27e19862e6e875abe96f110243d1b5aa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a6cd9df238bd8ee63bbaa4199395a09da">GRAD_Y_FILE_NAME</a>&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_grad_y_out.bmp&quot;</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gradient Y file name.  <a href="#a6cd9df238bd8ee63bbaa4199395a09da"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a196d5a36c4126bfa58ee4ea50baaae39">NUM_NODES</a>&nbsp;&nbsp;&nbsp;(6u)</td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="vx__tutorial__graph__image__gradients_8c.html#a838f2ff5f2c2496ad0fee70c0c93f2b6">vx_tutorial_graph_image_gradients</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Tutorial Entry Point.  <a href="#a838f2ff5f2c2496ad0fee70c0c93f2b6"></a><br/></td></tr>
</table>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="a8118656bb5a60090a1dbffa402168438"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::IN_FILE_NAME" ref="a8118656bb5a60090a1dbffa402168438" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define IN_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;colors.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Input file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00099">99</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<a class="anchor" id="ac7b4da9c3d57efe0b9187f424dba9324"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::PHASE_FILE_NAME" ref="ac7b4da9c3d57efe0b9187f424dba9324" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define PHASE_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_phase_out.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Phase file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00102">102</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<a class="anchor" id="a477612b28de7f3778ec98290da147134"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::MAGNITUDE_FILE_NAME" ref="a477612b28de7f3778ec98290da147134" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAGNITUDE_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_magnitude_out.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Magnitude file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00105">105</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<a class="anchor" id="a27e19862e6e875abe96f110243d1b5aa"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::GRAD_X_FILE_NAME" ref="a27e19862e6e875abe96f110243d1b5aa" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define GRAD_X_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_grad_x_out.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gradient X file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00108">108</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<a class="anchor" id="a6cd9df238bd8ee63bbaa4199395a09da"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::GRAD_Y_FILE_NAME" ref="a6cd9df238bd8ee63bbaa4199395a09da" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define GRAD_Y_FILE_NAME&nbsp;&nbsp;&nbsp;&quot;vx_tutorial_graph_image_gradients_grad_y_out.bmp&quot;</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gradient Y file name. </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00111">111</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<a class="anchor" id="a196d5a36c4126bfa58ee4ea50baaae39"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::NUM_NODES" ref="a196d5a36c4126bfa58ee4ea50baaae39" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define NUM_NODES&nbsp;&nbsp;&nbsp;(6u)</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00113">113</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a838f2ff5f2c2496ad0fee70c0c93f2b6"></a><!-- doxytag: member="vx_tutorial_graph_image_gradients.c::vx_tutorial_graph_image_gradients" ref="a838f2ff5f2c2496ad0fee70c0c93f2b6" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void vx_tutorial_graph_image_gradients </td>
          <td>(</td>
          <td class="paramname"></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tutorial Entry Point. </p>

<p><ul>
<li>Define objects that we wish to create in the OpenVX application.</li>
</ul>
<p>A vx_context object is defined which is used as input parameter for all subesquent OpenVX object create APIs </p>
<div class="fragment"><pre class="fragment">     */
    vx_context context;
    vx_image in_image = NULL;
    vx_image grad_x = NULL;
    vx_image grad_y = NULL;
    vx_image magnitude = NULL;
    vx_image phase = NULL;
    vx_image magnitude_image = NULL;
    vx_image grad_x_image = NULL;
    vx_image grad_y_image = NULL;
    vx_graph graph = NULL;
    vx_scalar shift = NULL;
    vx_node node[<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a196d5a36c4126bfa58ee4ea50baaae39">NUM_NODES</a>] = {NULL};
</pre></div><ul>
<li>Create OpenVX context.</li>
</ul>
<p>This MUST be done first before any OpenVX API call. The context that is returned is used as input for subsequent OpenVX APIs </p>
<div class="fragment"><pre class="fragment">     */
    context = vxCreateContext();
</pre></div><ul>
<li>Create image object.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file()</a> to see how a vx_image object is created and filled with RGB data from BMP file <a class="el" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a8118656bb5a60090a1dbffa402168438">IN_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">     */
    in_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_true_e);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(in_image);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    grad_x = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_x);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    grad_y = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_y);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    magnitude = vxCreateImage(context, width, height, VX_DF_IMAGE_S16);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(magnitude);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    magnitude_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(magnitude_image);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    grad_x_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_x_image);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    grad_y_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(grad_y_image);
</pre></div><ul>
<li>Create OpenVX image object.</li>
</ul>
<p>Creates an OpenVX image object of 'width' x 'height' and having data format 'df'. </p>
<div class="fragment"><pre class="fragment">     */
    phase = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
</pre></div><ul>
<li>Show image attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes()</a> to see how image attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(phase);
</pre></div><ul>
<li>Create OpenVX graph.</li>
</ul>
<div class="fragment"><pre class="fragment">     */
    graph = vxCreateGraph(context);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Sobel 3x3 node with in_image input and grad_x and grad_y output.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxSobel3x3Node(graph, in_image, grad_x, grad_y);
</pre></div><ul>
<li>Set node target CPU.</li>
</ul>
<p>Sets target CPU for node[i] to DSP1 </p>
<div class="fragment"><pre class="fragment">     */
    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Magnitude node with grad_x and grad_y input and magnitude output.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxMagnitudeNode(graph, grad_x, grad_y, magnitude);
</pre></div><ul>
<li>Set node target CPU.</li>
</ul>
<p>Sets target CPU for node[i] to DSP1 </p>
<div class="fragment"><pre class="fragment">     */
    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Phase node with grad_x and grad_y input and phase output.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxPhaseNode(graph, grad_x, grad_y, phase);
</pre></div><ul>
<li>Set node target CPU.</li>
</ul>
<p>Sets target CPU for node[i] to DSP2 </p>
<div class="fragment"><pre class="fragment">     */
    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP2);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Convert Depth node with magnitude input and magnitude_image output. The conversion policy is Saturate and the shift value is shift.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxConvertDepthNode(graph,
                    magnitude, magnitude_image,
                    VX_CONVERT_POLICY_SATURATE,
                    shift);
</pre></div><ul>
<li>Set node target CPU.</li>
</ul>
<p>Sets target CPU for node[i] to DSP1 </p>
<div class="fragment"><pre class="fragment">     */
    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Convert Depth node with grad_x input and grad_x_image output. The conversion policy is Saturate and the shift value is shift.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxConvertDepthNode(graph,
                    grad_x, grad_x_image,
                    VX_CONVERT_POLICY_SATURATE,
                    shift);
</pre></div><ul>
<li>Set node target CPU.</li>
</ul>
<p>Sets target CPU for node[i] to DSP1 </p>
<div class="fragment"><pre class="fragment">     */
    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP1);
</pre></div><ul>
<li>Create OpenVX node object.</li>
</ul>
<p>Creates an OpenVX Convert Depth node with grad_y input and grad_y_image output. The conversion policy is Saturate and the shift value is shift.</p>
<div class="fragment"><pre class="fragment">     */
    node[i] = vxConvertDepthNode(graph,
                    grad_y, grad_y_image,
                    VX_CONVERT_POLICY_SATURATE,
                    shift);
    vxSetReferenceName((vx_reference)node[i], <span class="stringliteral">&quot;GRAD_Y_IMAGE&quot;</span>);

    vxSetNodeTarget(node[i], VX_TARGET_STRING, TIVX_TARGET_DSP2);
</pre></div><ul>
<li>Verify graph object.</li>
</ul>
<p>Verifies that all parameters of graph object are valid.</p>
<div class="fragment"><pre class="fragment">     */
    status = vxVerifyGraph(graph);
</pre></div><ul>
<li>Show graph attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes()</a> to see how graph attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">     */
    <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
</pre></div><ul>
<li>Show node attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes()</a> to see how node attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">             */
            <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node[i]);
</pre></div><ul>
<li>Schedule graph.</li>
</ul>
<p>Schedules graph for future execution. vxVerifyGraph must return VX_SUCCESS before this function will pass.</p>
<div class="fragment"><pre class="fragment">         */
        vxScheduleGraph(graph);
</pre></div><ul>
<li>Wait graph.</li>
</ul>
<p>Waits for graph to complete.</p>
<div class="fragment"><pre class="fragment">         */
        vxWaitGraph(graph);
</pre></div><ul>
<li>Show graph attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes()</a> to see how graph attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
</pre></div><ul>
<li>Show node attributes.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes()</a> to see how node attributes are queried and displayed. </p>
<div class="fragment"><pre class="fragment">                 */
                <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node[i]);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#ac7b4da9c3d57efe0b9187f424dba9324" title="Phase file name.">PHASE_FILE_NAME</a>, phase);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a477612b28de7f3778ec98290da147134" title="Magnitude file name.">MAGNITUDE_FILE_NAME</a>, magnitude_image);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a27e19862e6e875abe96f110243d1b5aa" title="Gradient X file name.">GRAD_X_FILE_NAME</a>, grad_x_image);
</pre></div><ul>
<li>Save image object to bitmap file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a>.</li>
</ul>
<p>Follow the comments in <a class="el" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file()</a> to see how data in vx_image object is accessed to store pixel values from the image object to BMP file <a class="el" href="vx__tutorial__image__histogram_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">OUT_FILE_NAME</a> </p>
<div class="fragment"><pre class="fragment">         */
        <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__graph__image__gradients_8c.html#a6cd9df238bd8ee63bbaa4199395a09da" title="Gradient Y file name.">GRAD_Y_FILE_NAME</a>, grad_y_image);
</pre></div><ul>
<li>Release image object.</li>
</ul>
<p>Since we are done with using this image object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseImage(&amp;in_image);
    vxReleaseImage(&amp;grad_x);
    vxReleaseImage(&amp;grad_y);
    vxReleaseImage(&amp;grad_x_image);
    vxReleaseImage(&amp;grad_y_image);
    vxReleaseImage(&amp;phase);
    vxReleaseImage(&amp;magnitude);
    vxReleaseImage(&amp;magnitude_image);
</pre></div><ul>
<li>Release scalar object.</li>
</ul>
<p>Since we are done with using this scalar object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseScalar(&amp;shift);
</pre></div><ul>
<li>Release node object.</li>
</ul>
<p>Since we are done with using this node object, release it </p>
<div class="fragment"><pre class="fragment">             */
            vxReleaseNode(&amp;node[i]);
</pre></div><ul>
<li>Release graph object.</li>
</ul>
<p>Since we are done with using this graph object, release it </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseGraph(&amp;graph);
</pre></div><ul>
<li>Release context object.</li>
</ul>
<p>Since we are done using OpenVX context, release it. No further OpenVX API calls should be done, until a context is again created using vxCreateContext() </p>
<div class="fragment"><pre class="fragment">     */
    vxReleaseContext(&amp;context);
</pre></div> </p>

<p>Definition at line <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html#l00118">118</a> of file <a class="el" href="vx__tutorial__graph__image__gradients_8c_source.html">vx_tutorial_graph_image_gradients.c</a>.</p>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
